#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include "dpam.h"
#include "neato.c"

//******************
// main
//******************
main(int argc, char **argv){
  int mode,frequency,channel;

  DpSample *sample;

  // space away from the extender banner
  printf("\n");

  // see if mixer mode & frequency overridden at command line
  if(argc>=3){
    mode=atoi(argv[1]);
    frequency=atoi(argv[2]);
  } else mode=frequency=DM_DEFAULT;

  // install the mixer (also intalls DIGPAK and the timer)
  if(!DmInstall(mode,frequency,1)) return;

  // load test sample
  if(argc==4 || argc==2){
    // try to load the file specified on the command line
    sample=DpLoadSample(argv[argc-1],NULL);
  } else {
    // no file specified, try my main test sample
    // it's too long to include (208860 bytes), so an alternate is provided
    sample=DpLoadSample("samples\\puppy",NULL);
    if(!sample) sample=DpLoadSample("samples\\itstryng",NULL);
  } // end if-else

  // display some usage info if load fails
  if(!sample){
    printf("Sample not found (or doesn't fit in memory)\n");
    printf("USE: run  wavefile[.wav]   to use digauto.com\n");
    printf("or : test wavefile[.wav]   to use soundrv.com\n");
    goto error;
  } // end if

  // display basic info about the sample
  printf("Mode=%s\nFrequency=%i hz\nSize=%i bytes\nBuffer at 0x%p\n\n",
    DpModeName[sample->Mode],
    sample->Frequency,
    sample->Size,
    sample->Buffer);

  // play the sample in the background
  channel=DmPlay(sample);

  // wait until finished playing or a key is hit
  printf("Press 'n' for the neato color thingy from the PMODE/W examples\n");
  printf("or any other key to abort\n\n");
  printf("[%5s][%8s]\n","DMAC","size");
  while(DmPlaying()){
    if(kbhit()) if(getch()=='n'){
       neato();
       printf("[%5s][%8s]\n","DMAC","size");
    } else break;
    printf("[%5i][%8i]\r",DpReportDmac(),DmSetCounter(channel,DM_REPORT));
  } // end while
  printf("\n");

error:
  // remove the mixer
  DmRemove();
} // end main
