# base makefile
#
# Copyright (c) 1996 Manuel Suarez
# abalamahalamatandra@pobox.com
#
# November 11,1996 : added pack, bind & quiet for PMODE/W
# November 4, 1996 : cleaned up a little, particularly look of output
# November 3, 1996 : added debugging option
# October 29, 1996 : initial version
#
# use sys=system on command line
#   set sys=system to establish a new default
#
#   default=dos4g
#   nt=windows nt/95 console application
#   dos=16 bit dos
#
# use d=1 or d=2 to choose debugging options
#   set debug=1 or set debug=2 to make debugging default
#

#set compiler options
copts=/otexan /5r /wx /zq
asmopts=/wx /zq

#default to dos4g
sys_l=dos4g
sys_bt=dos
c=386

#check for environment, unless overridden at command line
!ifndef sys
!ifdef %sys
sys=$%sys
!endif
!endif

#pmode/w
!ifeq sys pmodew
sys_l=pmodew
!endif

#nt/win95 console
!ifeq sys nt
sys_l=nt
sys_bt=nt
!endif

#16 bit dos
!ifeq sys dos
sys_l=dos
c=
!endif

# check for debug option
!ifndef d
!ifdef %debug
d=$%debug
!endif
!endif

!ifdef d
copts+= /d$(d)
asmopts+= /d$(d)
!endif

# and, finally, put it all together
copts+= /bt$(sys_bt)
cl=wcl$(c) $(copts) /l$(sys_l)
cc=wcc$(c) $(copts)
cp=wpp$(c) $(copts)
asm=wasm $(asmopts) /bt$(sys_bt)
link=wlink option quiet system $(sys_l) file
pack=pmwlite /c4 $[*.exe >nul
bind=pmwbind /r $[*.exe >nul
quiet=pmwsetup /b0 $[*.exe >nul

# default behaviors

.c.exe :
  $cl $[*

.cpp.exe :
  $cl $[*

.asm.obj :
  $asm $[*

.asm.exe :
  $asm $[*
  $link $[*

.c.obj :
  $cc $[*

.cpp.obj :
  $cp $[*


