//******************
// DPMIX.H
//
// Copyright (c) 1996 Manuel Suarez
// abalamahalamatandra@pobox.com
//
// header file for DPMIX.C
//******************
#ifndef DPMIX_H
#define DPMIX_H

//******************
// defines
//******************
#define DM_TIMER_FREQ (TIMER_100hz)
#define DM_CALLBACK_FREQ (TIMER_50hz)
#define DM_MAX_VOL (32768)
#define DM_CENTER_BAL (0)
#define DM_RIGHT_BAL (32768)
#define DM_LEFT_BAL (-32768)
#define DM_DEFAULT (-1)
#define DM_REPORT (0x7fffffff)
#define DM_MAX_CHANNELS (32)

//******************
// Function prototypes
//******************
int DmInstall(int mode, int frequency,int channels);
void DmRemove(void);
int DmPlay(DpSample *sample);
int DmPlayExt(DpSample *sample,int vol,int bal);
int DmStop(int channel);
int DmSetVolume(int channel, int vol);
int DmSetBalance(int channel, int bal);
int DmSetCounter(int channel,int count);
int DmPlaying(void);

#endif
