/******************
KEY.C
keyboard handler

buffer entries must be manually cleared
will only store a 1 into a zeroed entry
on my keyboard, holding a key down repeats
so this allows clearing to 0 (test for !=0) to allow keyboard repeating
or clearing to -1 (test for >0) to disable repeating
when key is released, entry is cleared to zero 

Copyright (c) 1996 Manuel Suarez
abalamahalamatandra@pobox.com

FREE!!!!  Do whatcha want with it

November 5, 1996 : new email address, changed on/off to install/remove
March 19, 1996: some doc changes
March 14, 1996: added KeyHit, fixed KeyWait for >0, changes to docs
March 13, 1996: added KeyWait and documentation
March, 1996 : initial version
******************/
#include <dos.h>

#define KEY_IRQ 0x09
#define KEY_IN 0x60
#define KEY_ACK 0x61

void (_interrupt _far *OldKeyIsr)(); // old keyboard isr
volatile signed char KeyBuf[256];

//******************
// KeyIsr
// the keyboard interrupt service routine
//******************
void _interrupt _far KeyIsr(void){
int i;

i=inp(KEY_IN);

if(i&0x80) KeyBuf[i&0x7f]=0;
else if(!KeyBuf[i]) KeyBuf[i]=1;

outp(KEY_ACK,inp(KEY_ACK)|0x80);
outp(0x20,0x20);

} // end KeyIsr

//******************
// KeyInstall
// install keyboard handler
//******************
void KeyInstall(void){
  OldKeyIsr=_dos_getvect(KEY_IRQ);
  _dos_setvect(KEY_IRQ,KeyIsr);
} // end KeInstall

//******************
// KeyRemove
// restore bios keyboard handler
//******************
void KeyRemove(void){
  _dos_setvect(KEY_IRQ,OldKeyIsr);
} // end KeyRemove

//******************
// KeyWait
// wait until any key is >0
//******************
void KeyWait(void){
int i;

for(i=0;KeyBuf[i]<=0;i=(i+1)&0xff);

} // end KeyWait

//******************
// KeyHit
// test if any key is >0
// returns 0 for none, 1 for any
//******************
int KeyHit(void){
int i;

for(i=0;i<256;i++)
  if(KeyBuf[i]>0) return 1;

return 0;
} // end KeyHit