//******************
// TIMER.H
//
// Copyright (c) 1996 Manuel Suarez
// abalamahalamatandra@pobox.com
//
// Header file for TIMER.C
//******************

#ifndef TIMER_H
#define TIMER_H

//******************
// base timer frequency & some pre-calculated values
//******************
#define TIMER_FREQ (1193180)  // base timer frequency  (i.e. 1 hz)
#define TIMER_18hz   (65536)  // 18.2065 hz
#define TIMER_30hz   (39773)  // 29.9997 hz
#define TIMER_50hz   (23864)  // 49.9992 hz
#define TIMER_60hz   (19886)  // 60.0010 hz
#define TIMER_70hz   (17045)  // 70.0018 hz
#define TIMER_100hz  (11932)  // 99.9983 hz
#define TIMER_1000hz (1193)   // 1000.1509 hz

//******************
// global data (public)
//******************
extern volatile int Timer;

//******************
// prototypes for C
//******************
void TimerInstall(unsigned short timerval);
void TimerCallback(int timerval,void (*function)(void));
void TimerRemove();

#endif
