//******************
// TODPS.C
//
// converts .wav/.dps/raw files to
// simple .dps format
//
// Copyright (c) 1996 Manuel Suarez
// abalamahalamatandra@pobox.com
//
// wmake todps.exe
//
// November 9-10, 1996 : wildcards & operation on entire directory
// November 8, 1996 : initial version
//******************

#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <direct.h>
#include "src\dpam.c"

//******************
// strip the file name
//******************
void strip_name(char *string){
char *p;

p=string+strlen(string);
while(p>string && *p!='\\') p--;
if(*p=='\\') p++;
*p=0;

} // end strip_name

void LoadAndSave(char *filename,int mode, int frequency){
  int type;
  DpSample *ds;
  
  printf("%s: ",filename);
  ds=DpLoadSample(filename,&type);
  if(type) printf("%s\n",DpTypeName[type]);
  else  {printf("Not found, or too big, maybe?\n"); return;}
  if(mode!=-1) ds->Mode=mode;
  if(frequency!=-1) ds->Frequency=frequency;
  printf("%i bytes of %s @ %i hz\n",
    ds->Size,DpModeName[ds->Mode],ds->Frequency);
  DpSaveDps(filename,ds);
  printf("\n");
  DpFreeSample(ds);
  return;
} // end LoadAndPlay

main(int argc, char **argv){
  DIR *dp;
  int mode,frequency;
  char path[256];
  char filename[256];

  // make sure proper usage
  if(argc!=2 && argc!=4){
    printf(
      "USAGE:  todps filename[.ext] [mode frequency]  (wildcards OK)\n");
    return;
  } // end if

  // get mode & frequency overrides if specified
  if(argc==4){
    mode=atoi(argv[2]);
    frequency=atoi(argv[3]);
  } else {
    mode=frequency=-1;
  } // end if-else

  // open a directory, if filename fails as wildcard, try as single file
  if(!(dp=opendir(argv[1]))){
    LoadAndSave(argv[1],mode,frequency);
    return;
  } // end if

  // get the path - if '.' is 1st & no wildcard, path was specified w/o '\'
  // or ending in '\', otherwise, need to strip the filename off
  strcpy(path,argv[1]);
  if(*dp->d_name=='.' &&
     !strchr(path,'*') &&
     !strchr(path,'?') &&
     path[strlen(path)-1]!='\\') strcat(path,"\\");
  else strip_name(path);

  // loop through directory entries
  for(;;){
    if(!(dp=readdir(dp))) break;
    if(dp->d_attr&_A_SUBDIR) continue;
    strcpy(filename,path);
    strcat(filename,dp->d_name);
    LoadAndSave(filename,mode,frequency);
  } // end for

  closedir(dp);
} // end main

